#!/usr/bin/env python3

class ConfigurationError(Exception):
    def __init__(self, msg):
        super().__init__(self, msg)
        self.msg = msg

    def __str__(self):
        return self.msg

class ValidationError(Exception):
    def __init__(self, msg):
        super().__init__(self, msg)
        self.msg = msg


class StartupError(Exception):
    def __init__(self, msg, exit_code, error_details):
        super().__init__(self, msg)
        self.msg = msg
        self.exit_code = exit_code
        self.error_details = error_details

    def __str__(self):
        return '{}\n{}'.format(self.msg, self.error_details)